{$include lem_directives.inc}

unit FDosLevels;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, Contnrs,lemstyles,
  UMisc,
  LemTypes, LemCore, LemDosStyles, StdCtrls, lemdosfiles, lemfiles;

type
  TLevelNode = class
  private
  protected
  public
    Level: TLVLFileRec;
    IsClone: Boolean;
  published
  end;

  TLevelNodeList = class(TObjectList)
  private
    function GetItem(Index: Integer): TLevelNode;
  protected
  public
    function Add(Item: TLevelNode): Integer;
    procedure Insert(Index: Integer; Item: TLevelNode);
    property Items[Index: Integer]: TLevelNode read GetItem; default;
  published
  end;


  TFormDosLevels = class(TForm)
    Tree: TTreeView;
    procedure Form_Create(Sender: TObject);
    procedure Form_Destroy(Sender: TObject);
    procedure Tree_Change(Sender: TObject; Node: TTreeNode);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    FunNode, TrickyNode, TaxingNode, MayhemNode: TTreeNode;
    LevelNodeList: TLevelNodeList;

    { Private declarations }
  public
    { Public declarations }
  end;

function FormDosLevels: TFormDosLevels;

implementation

{$R *.dfm}

uses
  LemEdit, FMapEditor;

function FormDosLevels: TFormDosLevels;
var
  i: Integer;
begin
  with Screen do
  for i := 0 to CustomFormCount - 1 do
    if CustomForms[i] is TFormDosLevels then
    begin
      Result := TFormDosLevels(CustomForms[i]);
      Exit;
    end;

  Result := TFormDosLevels.Create(Application);

end;


{ TLevelNodeList }

function TLevelNodeList.Add(Item: TLevelNode): Integer;
begin
  Result := inherited Add(Item);
end;

function TLevelNodeList.GetItem(Index: Integer): TLevelNode;
begin
  Result := inherited Get(Index);
end;

procedure TLevelNodeList.Insert(Index: Integer; Item: TLevelNode);
begin
  inherited Insert(Index, Item);
end;

{ TFormDosLevels }

procedure TFormDosLevels.Form_Create(Sender: TObject);
var
  Sections: array[1..4] of TTreeNode;
  Sec, Lev: Integer;
  Sty: TDosOrigStyle;
  LVL: TLVLFileRec;
  N: TTreeNode;
  S: string;
  LN: TLevelNode;
//  info:TDosOrigFileParam;
begin
(*
  LevelNodeList := TLevelNodeList.Create;
//  windlg('start');
  Sty := TDosOrigStyle(StyleMgr.StyleList[STYLE_DOSORIG]);         //lemdosfiles
  with Tree.Items do
  begin
    Sections[1] := AddChild(nil, 'FUN');
    Sections[2] := AddChild(nil, 'TRICKY');
    Sections[3] := AddChild(nil, 'TAXING');
    Sections[4] := AddChild(nil, 'MAYHEM');
    FunNode := Sections[1];
    TrickyNode := Sections[2];
    TaxingNode := Sections[3];
    MayhemNode := Sections[4];

    for Sec := 1 to 4 do
      for Lev := 1 to 30 do
      begin
        LN := TLevelNode.Create;
        LevelNodeList.Add(LN);
        S := Sty.GetLevel(LN.Level, sec, lev, info{LN.IsClone});
        N := AddChild(Sections[Sec], i2s(Lev) + ' ' + S);
        N.Data := LN;
//        with ln.level do
  //        deb([Reserved1, reserved2])
//        deb([integer(n.data)sec,lev]);
      end;
    EndUpdate;
  end;
//  windlg('klaar');
*)
end;

procedure TFormDosLevels.Form_Destroy(Sender: TObject);
begin
  LevelNodeList.Free;
end;


procedure TFormDosLevels.Tree_Change(Sender: TObject; Node: TTreeNode);
var
  Sel: TTreeNode;

begin
  Sel := Tree.Selected;
  if Sel = nil then
    Exit;
  if Sel.Data = nil then
    Exit;
//  if TObject(Sel.Data) is TLevelNode then
  //  windlg('aha');
  with GlobalEditor do
  begin
    Beginupdate;
    try
      Style := StyleMgr[STYLE_DOSORIG];
      GlobalEditor.LoadFromLVLRec(TLevelNode(Sel.Data).Level);
    finally
      EndUpdate;
    end;
  end;
end;

procedure TFormDosLevels.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  action:=cafree;
end;

end.

