{$include lem_directives.inc}

unit FEditStatics;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ValEdit, UMisc,
  LemMisc,
  LemStyles,
  LemCore,
  LemEdit,
  LemDialogs,
  FBasicLevelEditor, StdCtrls, Mask, UMasterControls, GR32_Image, ExtCtrls,
  ComCtrls;

type
  TFormEditStatics = class(TBasicLevelEditorForm)
    EditTitle           : TEditEx;
    EditScreenStart     : TEditEx;
    EditGraphicSet      : TEditEx;
    EditGraphicSetEx: TEditEx;
    Bevel1: TBevel;


    EditReleaseRate     : TEditEx;
    EditLemmingsCount   : TEditEx;
    EditRescueCount     : TEditEx;
    EditTimeLimit       : TEditEx;
    EditClimberCount    : TEditEx;
    EditFloaterCount    : TEditEx;
    EditBlockerCount    : TEditEx;
    EditBomberCount     : TEditEx;
    EditBuilderCount    : TEditEx;
    EditBasherCount     : TEditEx;
    EditMinerCount      : TEditEx;
    EditDiggerCount     : TEditEx;
    ML1: TMasterLabel;
    MasterLabel1: TMasterLabel;
    MasterLabel2: TMasterLabel;
    MasterLabel3: TMasterLabel;
    MasterLabel4: TMasterLabel;
    MasterLabel5: TMasterLabel;
    MasterLabel6: TMasterLabel;
    MasterLabel7: TMasterLabel;
    MasterLabel8: TMasterLabel;
    MasterLabel9: TMasterLabel;
    MasterLabel10: TMasterLabel;
    MasterLabel11: TMasterLabel;
    MasterLabel12: TMasterLabel;
    MasterLabel13: TMasterLabel;
    MasterLabel14: TMasterLabel;
    MasterLabel15: TMasterLabel;
    MasterLabel16: TMasterLabel;
    EditStyle: TEditEx;
    BtnSelectStyle: TButton;
    CheckBoxSuperLemming: TCheckBox;
    LabelRescuePercentage: TMasterLabel;
    procedure Edit_KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure Form_Deactivate(Sender: TObject);
    procedure Edit_Exit(Sender: TObject);
    procedure BtnSelectStyle_Click(Sender: TObject);
    procedure CheckBoxSuperLemming_Click(Sender: TObject);
  private
    procedure LMLevelChanged(var Msg: TLMLevelChanged); message LM_LEVELCHANGED;
    procedure LMStaticsChanged(var Msg: TLMStaticsChanged); message LM_STATICSCHANGED;
    procedure UpdateInterface;
    procedure UpdateVar(Sender: TEditEx);
  protected
    procedure DoAfterSetEditor(Value: TLevelEditor); override;
  public
  end;

implementation

{$R *.dfm}

  // if change here then validate all eventhandlers (keypress!)
const
  tag_releaserate     = 1;
  tag_lemmingscount   = 2;
  tag_rescuecount     = 3;
  tag_timelimit       = 4;
  tag_climbercount    = 5;
  tag_floatercount    = 6;
  tag_bombercount     = 7;
  tag_blockercount    = 8;
  tag_buildercount    = 9;
  tag_bashercount     = 10;
  tag_minercount      = 11;
  tag_diggercount     = 12;
  tag_screenposition  = 13;
  tag_graphicset      = 14;
  tag_graphicsetex    = 15;
  tag_screenstart     = 16;
  tag_title           = 20;
  tag_superlemming    = 21;



function CalcPerc(Max, Rescue: Integer): integer;
begin
  if (Max = 0) or (Rescue = 0) then
    Result := 0
  else begin
    Result := (Rescue * 100) div Max;
  end;
end;

function CalcPercStr(Max, Rescue: Integer): string;
begin
  Result := i2s(CalcPerc(Max, Rescue)) + '%';
end;

{ TEditStaticsForm }

procedure TFormEditStatics.LMLevelChanged(var Msg: TLMLevelChanged);
begin
  UpdateInterface;
end;

procedure TFormEditStatics.LMStaticsChanged(var Msg: TLMStaticsChanged);
begin
  UpdateInterface;
end;

procedure TFormEditStatics.UpdateInterface;
begin
  if Editor = nil then
    Exit;
  with Editor, Statics do
  begin

    EditTitle.Text := Levelname;
    EditScreenStart.Text := i2s(ScreenPosition);

    if Style <> nil then
      EditStyle.Text := Style.StyleDescription;// StyleName; lemdialogs
    if Graph <> nil then
      EditGraphicSet.Text := i2s(Graph.GraphicSetId);// Graph.GraphicSetName;//GraphicSetToDescription(GraphicSet);

    EditGraphicSetEx.Text := i2s(GraphicSetEx);
    CheckBoxSuperLemming.Checked := SuperLemming;

    EditReleaseRate.Text     := i2s(ReleaseRate);
    EditLemmingsCount.Text   := i2s(LemmingsCount);
    EditRescueCount.Text     := i2s(RescueCount);
    LabelRescuePercentage.Caption := CalcPercStr(LemmingsCount, RescueCount);
    EditTimeLimit.Text       := i2s(TimeLimit);
    EditClimberCount.Text    := i2s(ClimberCount);
    EditFloaterCount.Text    := i2s(FloaterCount);
    EditBomberCount.Text     := i2s(BomberCount);
    EditBlockerCount.Text    := i2s(BlockerCount);
    EditBuilderCount.Text    := i2s(BuilderCount);
    EditBasherCount.Text     := i2s(BasherCount);
    EditMinerCount.Text      := i2s(MinerCount);
    EditDiggerCount.Text     := i2s(DiggerCount);
  end;
end;

procedure TFormEditStatics.UpdateVar(Sender: TEditEx);
var
  S: string;
begin
  if Editor = nil then
    Exit;
  S := Sender.Text;
  with Editor.Statics do
    case Sender.Tag of
      tag_title          : Editor.LevelName := Trim(S);
      tag_screenstart    : Editor.Statics.ScreenPosition := s2i(S);
      tag_releaserate    : ReleaseRate := s2i(S);
      tag_lemmingscount  :
        begin
          LemmingsCount := s2i(S);
          LabelRescuePercentage.Caption := CalcPercStr(LemmingsCount, RescueCount);
        end;
      tag_rescuecount    :
        begin
          RescueCount:= s2i(S);
          LabelRescuePercentage.Caption := CalcPercStr(LemmingsCount, RescueCount);
        end;
      tag_timelimit      : TimeLimit := s2i(S);
      tag_climbercount   : ClimberCount := s2i(S);
      tag_floatercount   : FloaterCount := s2i(S);
      tag_bombercount    : BomberCount := s2i(S);
      tag_blockercount   : BlockerCount := s2i(S);
      tag_buildercount   : BuilderCount := s2i(S);
      tag_bashercount    : BasherCount := s2i(S);
      tag_minercount     : MinerCount := s2i(S);
      tag_diggercount    : DiggerCount := s2i(S);
      tag_screenposition : ScreenPosition := s2i(S);
//      tag_graphicset     : GraphicSet := s2i(S);
      //tag_graphicsetex
    end;
  Sender.Modified := False;
end;

procedure TFormEditStatics.Edit_KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  E: TEditEx absolute Sender;
begin

  case Key of
    VK_RETURN:
      if Editor <> nil then
        if Sender is TEditEx then
          UpdateVar(E);
    VK_ESCAPE:
      begin
//        if Editor <> nil then
  //        if Sender is TEditEx then
    //        Log(['cancel']);
      end;
  end;

end;

procedure TFormEditStatics.FormCreate(Sender: TObject);
var
  R: TRect;
//  Ani: TLemmingAnimation;
const
  IntChars = ['0'..'9', '-'];
begin
  EditTitle.Tag             := tag_title;
  EditScreenStart.Tag       := tag_screenstart;
  EditGraphicSet.Tag        := tag_graphicset;
  CheckBoxSuperLemming.Tag  := tag_superlemming;

  EditReleaseRate.Tag       := tag_releaserate;
  EditLemmingsCount.Tag     := tag_lemmingscount;
  EditRescueCount.Tag       := tag_rescuecount;
  EditTimeLimit.Tag         := tag_timelimit;
  EditClimberCount.Tag      := tag_climbercount;
  EditFloaterCount.Tag      := tag_floatercount;
  EditBomberCount.Tag       := tag_bombercount;
  EditBlockerCount.Tag      := tag_blockercount;
  EditBuilderCount.Tag      := tag_buildercount;
  EditBasherCount.Tag       := tag_bashercount;
  EditMinerCount.Tag        := tag_minercount;
  EditDiggerCount.Tag       := tag_diggercount;


//  EditTitle.ValidChars           ;
  EditScreenStart.ValidChars     := IntChars;
  EditGraphicSet.ValidChars      := IntChars;
  EditReleaseRate.ValidChars     := IntChars;
  EditLemmingsCount.ValidChars   := IntChars;
  EditRescueCount.ValidChars     := IntChars;
  EditTimeLimit.ValidChars       := IntChars;
  EditClimberCount.ValidChars    := IntChars;
  EditFloaterCount.ValidChars    := IntChars;
  EditBlockerCount.ValidChars    := IntChars;
  EditBomberCount.ValidChars     := IntChars;
  EditBuilderCount.ValidChars    := IntChars;
  EditBasherCount.ValidChars     := IntChars;
  EditMinerCount.ValidChars      := IntChars;
  EditDiggerCount.ValidChars     := IntChars;


{  with Image321 do
  begin
    Ani := PictureMgr.WalkerAnimation;
    R := Ani.CalcFrameRect(0);
    bitmap.width := RectWidth(R);
    bitmap.height := RectHeight(R);
    bitmap.Draw(R, R, Ani.Bitmap);
  end;     }

end;

procedure TFormEditStatics.Form_Deactivate(Sender: TObject);
var
  E: TEditEx;
begin
//exit;
  if ActiveControl is TEditEx then
  begin
    E := TEditEx(ActiveControl);
    if Assigned(E.OnExit) then
      E.OnExit(E);
  end;
end;

procedure TFormEditStatics.Edit_Exit(Sender: TObject);
begin
  if TEditEx(Sender).Modified then
    try
      UpdateVar(TEditEx(Sender));
    except
      TEditEx(Sender).SetFocus;
      raise;
    end;
end;

procedure TFormEditStatics.DoAfterSetEditor(Value: TLevelEditor);
begin
  UpdateInterface;
end;

procedure TFormEditStatics.BtnSelectStyle_Click(Sender: TObject);
var
  S: TBaseLemmingStyle;
begin
  S := Editor.Style;
  if Dlg_AskStyle(S) = mrOK then
    Editor.Style := S;

//  editor.Style := stylemgr.Styles[style_dosohno];
end;

procedure TFormEditStatics.CheckBoxSuperLemming_Click(Sender: TObject);
begin
  Editor.Statics.SuperLemming := CheckBoxSuperLemming.Checked;
end;

end.
(*
var
  E: TEditEx absolute Sender;
begin
  Assert(Sender is TEditEx, 'sender error');
  if not (Key in ['0'..'9', '-']) then
  begin
    case E.Tag of
      tag_releaserate..tag_title:
        begin
          Key := #0;
        end;
      //tag_title  = 20;
    end;
  end;
*)
