{$include lem_directives.inc}

unit FViewLevels;

{-------------------------------------------------------------------------------
  Form to view all levels of a style
-------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  lemedit, lemstyles, lemdosstyles, lemlemministyles, contnrs,lemfiles,  LemDosFiles, LemCore,
fgame, jpeg,gr32,  umisc,  Dialogs, VirtualTrees, StdCtrls, GR32_Image, ComCtrls,
lemdosarc,
  Menus;

type
  TStringObject = class
  public
    S: string;
  end;

  TLevelNode = class
  private
  protected
  public
    Level: TLVLFileRec;
//    InFile: string;
    IsClone: Boolean;
    Inf: TLevelInfoRec;
  published
  end;

  TLevelNodeList = class(TObjectList)
  private
    function GetItem(Index: Integer): TLevelNode;
  protected
  public
    function Add(Item: TLevelNode): Integer;
    procedure Insert(Index: Integer; Item: TLevelNode);
    property Items[Index: Integer]: TLevelNode read GetItem; default;
  published
  end;


type
  TFormViewLevels = class(TForm)
    Tree: TVirtualStringTree;
    PopupMenu: TPopupMenu;
    Info1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TreeGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure TreeFreeNode(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure TreeIncrementalSearch(Sender: TBaseVirtualTree;
      Node: PVirtualNode; const SearchText: WideString;
      var Result: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TreeChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure Button1Click(Sender: TObject);
    procedure TreeChecking(Sender: TBaseVirtualTree; Node: PVirtualNode;
      var NewState: TCheckState; var Allowed: Boolean);
    procedure TreeChecked(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure Tree_GetHint(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; var LineBreakStyle: TVTTooltipLineBreakStyle;
      var HintText: WideString);
    procedure Info1Click(Sender: TObject);
  private
//    counter: Integer;
//    FunNode, TrickyNode,
//    LevelNodeList: TLevelNodeList;
    fCurrentStyle: TBaseLemmingStyle;

    procedure FillTree;
    procedure InternalFillTree;
    function LevelNode(aNode: PVirtualNode): TLevelNode;
    procedure SetCurrentStyle(const Value: TBaseLemmingStyle);
    { Private declarations }
  public
    property CurrentStyle: TBaseLemmingStyle read fCurrentStyle write SetCurrentStyle;
    { Public declarations }
  end;

function FormViewLevels(aStyle: TBaseLemmingStyle): TFormViewLevels;

implementation

{$R *.dfm}

function FormViewLevels(aStyle: TBaseLemmingStyle): TFormViewLevels;
var
  i: Integer;
begin
  with Screen do

  for i := 0 to CustomFormCount - 1 do
    if CustomForms[i] is TFormViewLevels then
    begin
      Result := TFormViewLevels(CustomForms[i]);
      Result.CurrentStyle := aStyle;
      Exit;
    end;

  Result := TFormViewLevels.Create(Application);
  Result.CurrentStyle := aStyle;

end;

type
  PNodeData = ^TNodeData;
  TNodeData = record
    O: TObject;
  end;

{ TLevelNodeList }

function TLevelNodeList.Add(Item: TLevelNode): Integer;
begin
  Result := inherited Add(Item);
end;

function TLevelNodeList.GetItem(Index: Integer): TLevelNode;
begin
  Result := inherited Get(Index);
end;

procedure TLevelNodeList.Insert(Index: Integer; Item: TLevelNode);
begin
  inherited Insert(Index, Item);
end;



procedure TFormViewLevels.FormCreate(Sender: TObject);
(*var
  Sections: array[1..4] of PVirtualNode;
  Sec, Lev: Integer;
  Sty: TDosOrigStyle;
  LVL: TLVLFileRec;
  N: PVirtualNode;
  S: string;
  LN: TLevelNode;
  Info: TDosOrigFileParam;

    function NewStringNode(const S: string): TStringObject;
    begin
      Result := TStringObject.Create;
      Result.S := S;
    end; *)
begin
 (*
exit;
  Tree.NodeDataSize := SizeOf(TNodeData); // pointer naar object

//  LevelNodeList := TLevelNodeList.Create(false);

  //  windlg('start');

  Sty := TDosOrigStyle(StyleMgr.StyleList[STYLE_DOSORIG]);         //lemdosfiles
  with Tree do
  begin
    Sections[1] := AddChild(nil, NewStringNode('Fun'));
    Sections[2] := AddChild(nil, NewStringNode('Tricky'));
    Sections[3] := AddChild(nil, NewStringNode('Taxing'));
    Sections[4] := AddChild(nil, NewStringNode('Mayhem'));

//    CheckType[Sections[4]] := ctcheckbox;
{     TCheckType = (
    ctNone,
    ctTriStateCheckBox,
    ctCheckBox,
    ctRadioButton,
    ctButton
  );}

    for Sec := 1 to 4 do
      for Lev := 1 to 30 do
      begin
        LN := TLevelNode.Create;
//        LevelNodeList.Add(LN);
        S := Sty.GetLevel(LN.Level, sec, lev, info{.dIsClone{LN.IsClone});
        N := AddChild(Sections[Sec], LN{i2s(Lev) + ' ' + S});
//        N.Data := LN;
//        with ln.level do
  //        deb([Reserved1, reserved2])
//        deb([integer(n.data)sec,lev]);
      end;

//    EndUpdate;
  end;
   *)

end;

procedure TFormViewLevels.FormDestroy(Sender: TObject);
begin
//  LevelNodeList.Free;
end;

procedure TFormViewLevels.TreeGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
var
  P: PNodeData;
begin
//  if Column <> 0 then exit;
  P := Sender.GetNodeData(Node);

  if Assigned(P) then
    if Assigned(P^.O) then
    begin
      if P^.O is TLevelPack then
        CellText := TLevelPack(P^.O).LevelPackName
      else if P^.O is TPackSection then
        CellText := TPackSection(P^.O).SectionName
      else if P^.O is TLevelInfo then
        CellText := TLevelInfo(P^.O).TrimmedTitle + ' (' + i2s(TLevelInfo(P^.O).ID + 1) + ')';
    end;

exit;



  if Assigned(P) then
    if Assigned(P^.O) then
      if P^.O is TStringObject then
    begin
      CellText := TStringObject(P^.O).S;
//      CellText := 'ok';

    end
    else if P^.O is TLevelNode then
    begin
      //CellText := Trim(TLevelNode(P^.O).Level.LevelName) + ' (' + i2s(node^.index) + ')';
      CellText := Trim(TLevelNode(P^.O).Inf.iTitle) + ' (' + i2s(node^.index) + ')';
//      if TLevelNode(P^.O).IsClone then
  //      CellText := CellText + ' clone'

    end;

//  if O is TStringNode then
  //  CellText := TStringNode(O).S;
end;

procedure TFormViewLevels.TreeFreeNode(Sender: TBaseVirtualTree;
  Node: PVirtualNode);
var
  P: PNodeData;
begin
  P := Sender.GetNodeData(Node);

  exit;

  if Assigned(P) then
    if Assigned(P^.O) then
//      if P^.O is TStringObject then
        P^.O.Free;

end;

procedure TFormViewLevels.TreeIncrementalSearch(Sender: TBaseVirtualTree;
  Node: PVirtualNode; const SearchText: WideString; var Result: Integer);
begin
  Result := 0;
  if Pos(UpperCase(SearchText), UpperCase(Tree.Text[Node, Tree.FocusedColumn])) <> 1 then
    Result := 1;
end;

procedure TFormViewLevels.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TFormViewLevels.TreeChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
var
  P: PNodeData;
  LI: TLevelInfo;
begin
  if GlobalEditor.IsLocked then
    Exit;
  if Node <> Tree.FocusedNode then
    Exit;

  P := Sender.GetNodeData(Node);
  if Assigned(P) then
    if Assigned(P^.O) then
      if P^.O is TLevelInfo then
      begin
        LI := TLevelInfo(P^.O);
        fCurrentStyle.LevelLoader.LoadLevel(LI, GlobalEditor);
      end;
end;

procedure TFormViewLevels.Button1Click(Sender: TObject);
var
  bmp:tbitmap32; ibp:tbitmap;
  jpg: tjpegimage;
  R: TLevelRenderer;
  L: TLevel;
  N: TLevelNode;

begin
(*
  P := tree.GetNodeData(tree.FocusedNode);

  if Assigned(P) then
    if Assigned(P^.O) then
      if P^.O is TLevelInfo then
      begin
        LI := TLevelInfo(P^.O);

      with TFormGame.Create(nil) do
      begin
        Lev := TLevel.Create(nil);
//        extr:=tdosdatarchive.create;
//        mem:=tmemorystream.create;
//        extr.LoadFromFile(li.DosLevelPackFileName);
//        extr.ExtractSection(li.DosLevelPackIndex);
//        Lev.LoadFromStream(mem, fCurrentStyle, lffLVL);
//        mem.free;
//        extr.free;
        fCurrentStyle.LevelLoader.LoadLevel(li, lev);
        LoadAndPlay(Lev);
        Lev.Free;
        Free;
      end;
      end;
*)

//exit;

  N := LevelNode(Tree.FocusedNode);
if n=nil then exit;
  bmp:=tbitmap32.create;
  ibp:=tbitmap.create;
  jpg:=TJPEGImage.create;
  R:=TLevelRenderer.create(nil);
//  r.Options := [roterrain, roobject]
  l:=tlevel.create(nil);

  l.beginupdate;
  r.levelbitmap:=bmp;
  l.style:=fcurrentstyle;//stylemgr[style_Dosorig];
  l.LoadFromLVLRec(n.Level);
  r.RenderLevel(l);
  ibp.assign(bmp);
  jpg.Assign(ibp);
  bmp.savetofile('d:\try.bmp');
  jpg.SaveToFile('d:\try.jpg');
  l.endupdate;


  l.free;
  r.free;
  jpg.free;
  bmp.free;
  ibp.free;
end;

function TFormViewLevels.LevelNode(aNode: PVirtualNode): TLevelNode;
var
  P: PNodeData;
begin
  Result := nil;
  if aNode = nil then exit;

  P := tree.GetNodeData(aNode);
  if Assigned(P) then
    if Assigned(P^.O) then
      if P^.O is TLevelNode then
        Result := TLevelNode(P^.O);
end;

procedure TFormViewLevels.TreeChecking(Sender: TBaseVirtualTree;
  Node: PVirtualNode; var NewState: TCheckState; var Allowed: Boolean);
begin
//
end;

procedure TFormViewLevels.TreeChecked(Sender: TBaseVirtualTree;
  Node: PVirtualNode);
begin
//
end;

procedure TFormViewLevels.SetCurrentStyle(const Value: TBaseLemmingStyle);
begin
  if fCurrentStyle = Value then Exit;
  fCurrentStyle := Value;
  FillTree;
  Caption := 'View levels of ' + Value.StyleDescription;
end;

procedure TFormViewLevels.InternalFillTree;
var
  LP: TLevelPack;
  LS: TPackSection;
  LI: TLevelInfo;
  PackNode, SectionNode, LevelNode: PVirtualNode;
  iPack, iSection, iLevel: Integer;
  Def: TDefaultsRec;

begin
  Tree.Clear;
  Tree.NodeDataSize := SizeOf(TNodeData);

  with CurrentStyle.LevelLoader, Tree do
  begin
    CurrentStyle.GetStyleParams(Def);
    // packs
    for iPack := 0 to LevelPackCount - 1 do
    begin
      LP := LevelPacks[iPack];
      if Def.MultiPacks then
        PackNode := AddChild(nil, LP)
      else
        PackNode := nil;
      // sections
      for iSection := 0 to LP.PackSections.Count - 1 do
      begin
        LS := LP.PackSections[iSection];
        SectionNode := AddChild(PackNode, LS);
        // levels
        for iLevel := 0 to LS.LevelInfos.Count - 1 do
        begin
          LI := LS.LevelInfos[iLevel];
          LevelNode := AddChild(SectionNode, LI);
        end;
      end;
    end;
  end;

end;


procedure TFormViewLevels.FillTree;
begin
  if fCurrentStyle.LevelLoader = nil then
    Exit;
  fCurrentStyle.LevelLoader.Prepare;
  InternalFillTree;
end;

procedure TFormViewLevels.Tree_GetHint(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex;
  var LineBreakStyle: TVTTooltipLineBreakStyle; var HintText: WideString);
var
  P: PNodeData;
//  O: TObject;
begin
  hinttext := 'where is the hint';
exit;

//  if Column <> 0 then exit;
  P := Sender.GetNodeData(Node);

  if Assigned(P) then
    if Assigned(P^.O) then
    begin
      {if P^.O is TLevelPack then
        CellText := TLevelPack(P^.O).LevelPackName
      else if P^.O is TPackSection then
        CellText := TPackSection(P^.O).SectionName
      else
      }if P^.O is TLevelInfo then
        HintText := 'hoi';//TLevelInfo(P^.O).TrimmedTitle + ' (' + i2s(TLevelInfo(P^.O).ID + 1) + ')';
    end;
end;

procedure TFormViewLevels.Info1Click(Sender: TObject);
var
  P: PNodeData;
  LI: TLevelInfo;
  N: PVirtualNode;

    procedure ShowMsg(const S: string);
    begin
      MessageDlg(S, mtInformation, [mbOK], 0);
    end;

begin
  
  N := Tree.FocusedNode;
  P := Tree.GetNodeData(N);
  if Assigned(P) then
    if Assigned(P^.O) then
      if P^.O is TLevelInfo then
      begin
        LI := TLevelInfo(P^.O);

        with LI do
        ShowMsg(
          'Title: ' + TrimmedTitle + #13 +
          'Dos LevelPack: ' + DosLevelPackFileName +  #13 +
          'Dos Pack Index: ' + i2s(DosLevelPackIndex) +  #13 +
          'Dos OddTableClone: ' + BoolStr(DosIsOddTableClone) +  #13 +
          'Dos OddTableFileName: ' + DosOddTableFileName +  #13 +
          'Dos OddTable Index: ' + i2s(DosOddTableIndex) +  #13 +
          'OwnerFile: ' + OwnerFile
        );
        Exit;
      end;

  // no info
  ShowMsg('No level selected');
  Exit;


end;

end.

//        deb([li.DosLevelPackFileName, li.DosLevelPackIndex]);

