unit LemControls;

(*
procedure TSkillPanelToolbar.MinimapHighlightLayer_Paint(Sender: TObject; Buffer: TBitmap32);
{
  coordinaten binnen rode kader voor minimap
  x1=208
  x2=311     breedte = 104              (*16=1664)
  y1=18
  y2=37      hoogte = 20                (*8=160)

  width  = 1/16
  height = 1/8

}
var
  A, R: TRect;

begin
  {

  A := Rect(208, 18, 311 + 1, 37 + 1);

  with fViewPortRect do
    A := Rect(208 + Left div 16, 18, 208 + Left div 16 + 20, 37 + 1);

  R := MakeRect(fMinimapHighlightLayer.GetAdjustedRect(FloatRect(A)));
  Buffer.FrameRectS(R.Left, R.Top, R.Right, R.Bottom, clWhite32);
   }

end;
*)



interface

uses
  Windows, Classes, Graphics, Controls, SysUtils,
  GR32, GR32_Image, GR32_Layers, LemDosBmp,
  UMisc, LemCore, LemTypes, LemDosFiles, LemDosStyles, LemStyles,
  LemInterfaces, LemGame;

const
  MiniMapBounds: TRect = (
    Left: 208;
    Top: 18;
    Right: 311;
    Bottom: 37
  );

const
  PURPLEFONTCOUNT = ord('~') - ord('!') + 1;
  PurpleFontCharSet = ['!'..'~'];
  
type
  TPurpleFont = class(TComponent)
  private
    function GetBitmapOfChar(Ch: Char): TBitmap32;
    procedure Combine(F: TColor32; var B: TColor32; M: TColor32);
  protected
  public
    fBitmaps: array[0..PURPLEFONTCOUNT - 1] of TBitmap32;
    constructor Create(aOwner: TComponent); override;
    destructor Destroy; override;
    property BitmapOfChar[Ch: Char]: TBitmap32 read GetBitmapOfChar;
  published
  end;


//  TMiniMap = class(TCustomControl)


  {-------------------------------------------------------------------------------
    maybe this must be handled by lemgame (just bitmap writing)

  // info positions types:
  // 1. BUILDER(23)             1/14
  // 2. OUT 28                  15/23
  // 3. IN 99%                  24/31
  // 4. TIME 2-31               32/40

  -------------------------------------------------------------------------------}
  TSkillPanelToolbar = class(TCustomControl, IGameInfoView)
  private
    fStyle         : TBaseLemmingStyle;
    fGraph         : TBaseDosGraphicSet;

    fImg           : TImage32;
    //fButtonHighlightLayer: TPositionedLayer;
    //fMinimapHighlightLayer: TPositionedLayer;

    fOriginal      : TBitmap32;
    fLevel         : TLevel;
    fSkillFont     : array['0'..'9', 0..1] of TBitmap32;
    fInfoFont      : array[0..37] of TBitmap32; {%} { 0..9} {A..Z}
    fGame          : TLemmingGame;
    fButtonRects   : array[TButtonSkill] of TRect;
    fViewPortRect  : TRect;

    procedure SkillFontCombine(F: TColor32; var B: TColor32; M: TColor32);

    procedure SetLevel(const Value: TLevel);

    procedure ImgMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure ImgMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer;
      Layer: TCustomLayer);
    procedure ImgMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);

    procedure SetGame(const Value: TLemmingGame);

  protected
    //procedure Paint; override;
    procedure ReadBitmapFromStyle; virtual;
    procedure ReadFont;
    procedure SetButtonRects;

//    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
  public
    fLastDrawnStr: string40;
    fNewDrawStr: string40;
    RedrawnChars: Integer;
    constructor Create(aOwner: TComponent); override;
    destructor Destroy; override;
//    procedure DrawInfo(aType: TInfoType; const S: string);
    procedure DrawNewStr;
    property Img: TImage32 read fImg;

    procedure SetViewPort(const R: TRect);
    procedure RedrawAndUpdateInfo;

  { IGameInfoView support }
    procedure DrawSkillCount(aButton: TButtonSkill; aNumber: Integer);
    procedure DrawButtonSelector(aButton: TButtonSkill; Highlight: Boolean);
    procedure DrawMinimap(Map: TBitmap32);
    procedure SetInfoCursorLemming(const Lem: string; Num: Integer);
    procedure SetInfoError(const Error: string; Code: Integer);
    procedure SetInfoLemmingsOut(Num: Integer);
    procedure SetInfoLemmingsIn(Num, Max: Integer);
    procedure SetInfoMinutes(Num: Integer);
    procedure SetInfoSeconds(Num: Integer);

  published
    procedure SetStyleAndGraph(const Value: TBaseLemmingStyle;
      const aGraph: TBaseDosGraphicSet; aScale: Integer);
//    property Style: TBaseLemmingStyle read fStyle write SetStyle;
    property Level: TLevel read fLevel write SetLevel;
    property Game: TLemmingGame read fGame write SetGame;

  end;


  TDosScreen = class(TCustomControl)
  private
    fMainDat: string;
    fImg : TImage32;

    //fBackGround: TBitmap32;
    procedure SetMainDat(const Value: string);
  protected
  public
    constructor Create(aOwner: TComponent); override;
    destructor Destroy; override;
    property MainDat: string read fMainDat write SetMainDat;
  published
  end;

  TDosLevelIntroScreen = class(TDosScreen)
  private
  protected
  public
  published
  end;

implementation

uses
  Types;

function PtInRectEx(const Rect: TRect; const P: TPoint): Boolean;
{-------------------------------------------------------------------------------
  This one also returns true when P.X is exactly ON Rect.Right or P.Y is exactly
  ON Rect.Bottom, while the functions in the VCL or Windows do return false in
  this cases.
-------------------------------------------------------------------------------}
begin
  Result := (P.X >= Rect.Left) and (P.X < Rect.Right) and (P.Y >= Rect.Top)
    and (P.Y < Rect.Bottom);
end;


{ TPurpleFont }

procedure TPurpleFont.Combine(F: TColor32; var B: TColor32; M: TColor32);
// just show transparent
begin
  if F <> 0 then B := F;
end;

constructor TPurpleFont.Create(aOwner: TComponent);
var
  i: Integer;
{-------------------------------------------------------------------------------
  The purple font has it's own internal pixelcombine.
  I don't think this ever has to be different.
-------------------------------------------------------------------------------}
begin
  inherited;
  for i := 0 to PURPLEFONTCOUNT - 1 do
  begin
    fBitmaps[i] := TBitmap32.Create;
    fBitmaps[i].OnPixelCombine := Combine;
    fBitmaps[i].DrawMode := dmCustom;
  end;
end;

destructor TPurpleFont.Destroy;
var
  i: Integer;
begin
  for i := 0 to PURPLEFONTCOUNT - 1 do
    fBitmaps[i].Free;
  inherited;
end;

function TPurpleFont.GetBitmapOfChar(Ch: Char): TBitmap32;
var
  Idx: Integer;
begin
//  Ch := UpCase(Ch);
  Assert(Ch in ['!'..'~'], 'character error');
  idx := ord(ch) - ord('!');
  Assert(Idx in [0..PURPLEFONTCOUNT - 1], 'character idx error ' + i2s(idx));

  Result := fBitmaps[Idx];

  exit;


//  Assert(Ch in ['%', '0'..'9', '-', 'A'..'Z'], 'Char error');
//  Idx := -1;
//  C := UpCase(LocalS[i]);
  case Ch of
    '%':
      begin
        idx := 0;
      end;
    '0'..'9':
      begin
        idx := ord(ch) - ord('0') + 1;
      end;
    '-':
      begin
        idx := 11;
      end;
    'A'..'Z':
      begin
        idx := ord(ch) - ord('A') + 12;
      end;
  else
    raise Exception.Create('purple font getbitmap error');
  end;

  Result := fBitmaps[Idx];
end;

{ TSkillPanelToolbar }

constructor TSkillPanelToolbar.Create(aOwner: TComponent);
var
  c: Char;
  i: Integer;
begin
  inherited;
//  fBitmap := TBitmap.Create;
  fImg := TImage32.Create(Self);
  fImg.Parent := Self;
  fImg.RepaintMode := rmOptimizer;

  fImg.OnMouseDown := ImgMouseDown;
  fImg.OnMouseMove := ImgMouseMove;
  fImg.OnMouseUp := ImgMouseUp;


{  fButtonHighlightLayer := TPositionedLayer.Create(Img.Layers);
  fButtonHighlightLayer.MouseEvents := False;
  fButtonHighlightLayer.Scaled := True;
  fButtonHighlightLayer.OnPaint := ButtonHighlightLayer_Paint; }

{  fMinimapHighlightLayer := TPositionedLayer.Create(Img.Layers);
  fMinimapHighlightLayer.MouseEvents := False;
  fMinimapHighlightLayer.Scaled := True;
  fMinimapHighlightLayer.OnPaint := MinimapHighlightLayer_Paint; }

  fOriginal := TBitmap32.Create;

  for i := 0 to 37 do
  begin
    fInfoFont[i] := TBitmap32.Create;
    with fInfoFont[i] do
    begin
//      DrawMode := dmCustom;
  //    OnPixelCombine := SkillFontCombine; 
    end;
  end;

  for c := '0' to '9' do
    for i := 0 to 1 do
    begin
      fSkillFont[c, i] := TBitmap32.Create;
    end;


  // info positions types:
  // stringspositions=cursor,out,in,time=1,15,24,32
  // 1. BUILDER(23)             1/14               0..13      14
  // 2. OUT 28                  15/23              14..22      9
  // 3. IN 99%                  24/31              23..30      8
  // 4. TIME 2-31               32/40              31..39      9
                                                           //=40
  fLastDrawnStr := StringOfChar(' ', 40);
  fNewDrawStr := StringOfChar(' ', 40);
  fNewDrawStr := '..............' + 'OUT_.....' + 'IN_.....' + 'TIME_.-..';
//  windlg([length(fnewDrawStr)]);

  Assert(length(fnewdrawstr) = 40, 'length error infostring');




end;

destructor TSkillPanelToolbar.Destroy;
var
  c: Char;
  i: Integer;
begin


  for i := 0 to 37 do
    fInfoFont[i].Free;

//  fBitmap.Free;
  for c := '0' to '9' do
    for i := 0 to 1 do
      fSkillFont[c, i].Free;

  fOriginal.Free;
  inherited;
end;

procedure TSkillPanelToolbar.DrawButtonSelector(aButton: TButtonSkill; Highlight: Boolean);
var
  R: TRect;
  C: TColor32;
  A: TRect;
begin
//  if Highlight then
  //if aButton in [bskFaster, bskSlower, bskPause, bskNuke] then
    //Exit;

   { TODO : use other WHITE ?}

  case Highlight of
    False :
      begin
        R := fButtonRects[aButton];
        Inc(R.Right);
        Inc(R.Bottom, 2);

        // top
        A := R;
        A.Bottom := A.Top + 1;
        fOriginal.DrawTo(fImg.Bitmap, A, A);

        // left
        A := R;
        A.Right := A.Left + 1;
        fOriginal.DrawTo(fImg.Bitmap, A, A);

        // right
        A := R;
        A.Left := A.Right - 1;
        fOriginal.DrawTo(fImg.Bitmap, A, A);

        // bottom
        A := R;
        A.Top := A.Bottom - 1;
        fOriginal.DrawTo(fImg.Bitmap, A, A);

  //      fOriginal.DrawTo(fImg.Bitmap, R, R);
    //    fOriginal.DrawTo(fImg.Bitmap, R, R);
      end;
    True  :
      begin
        R := fButtonRects[aButton];
        Inc(R.Right);
        Inc(R.Bottom, 2);
        C := DosPaletteEntryToColor32(DosInLevelPalette[3]);
        fImg.Bitmap.FrameRectS(R, C);
//        C := clWhite32;
        //fImg.Bitmap.FrameRectS(fButtonRects[aButton], clWhite);
      end;
  end;
end;
(*
procedure TSkillPanelToolbar.DrawInfo(aType: TInfoType; const S: string);
var
  C: char;
  i, x, y, idx: integer;
  LocalS: string;
begin
  // optimze this by pre-drawing
     // - "OUT "
     // - "IN "
     // - "TIME "
     // - "-"

  // info positions types:
  // 1. BUILDER(23)             1/14               0..13
  // 2. OUT 28                  15/23              14..22
  // 3. IN 99%                  24/31              23..30
  // 4. TIME 2-31               32/40              31..39

  case aType of
    itCursor: x := 0;
    itOut: x := 14 * 8;
    itIn : x := 23 * 8;
    itTime: x := 31 * 8
  end;
  y := 0;
  LocalS := PadR(S, 14);
  for i := 1 to Length(LocalS) do
  begin
    idx := -1;
    C := UpCase(LocalS[i]);
    case C of
      '%':
        begin
          idx := 0;
        end;
      '0'..'9':
        begin
          idx := ord(c) - ord('0') + 1;
        end;
      '-':
        begin
          idx := 11;
        end;
      'A'..'Z':
        begin
          idx := ord(c) - ord('A') + 12;
        end;
    end;

//    finfoforn[idx]

    //Assert(idx <= High(fInfoFont), 'infofont error');

    if idx >= 0 then
      fInfoFont[idx].DrawTo(fimg.Bitmap, x, 0)
    else
      fimg.Bitmap.FillRectS(x, y, x + 8, y + 16, 0);

    Inc(x, 8);

  end;

//  fImg.Bitmap.
end;
*)

procedure TSkillPanelToolbar.DrawNewStr;
var
  O, N: char;
  i, x, y, idx: integer;
//  LocalS: string;
  Changed: Integer;
begin

  Changed := 0;
  // optimze this by pre-drawing
     // - "OUT "
     // - "IN "
     // - "TIME "
     // - "-"

  // info positions types:
  // 1. BUILDER(23)             1/14               0..13
  // 2. OUT 28                  15/23              14..22
  // 3. IN 99%                  24/31              23..30
  // 4. TIME 2-31               32/40              31..39

{  case aType of
    itCursor: x := 0;
    itOut: x := 14 * 8;
    itIn : x := 23 * 8;
    itTime: x := 31 * 8
  end; }
  y := 0;


  x := 0;

  for i := 1 to 40 do
  begin
    idx := -1;


    O := UpCase(fLastDrawnStr[i]);
    N := UpCase(fNewDrawStr[i]);

    if O <> N then
    begin

      case N of
        '%':
          begin
            idx := 0;
          end;
        '0'..'9':
          begin
            idx := ord(n) - ord('0') + 1;
          end;
        '-':
          begin
            idx := 11;
          end;
        'A'..'Y':
          begin
            idx := ord(n) - ord('A') + 12;
          end;
        'Z':
          begin
            idx := ord(n) - ord('A') + 12;
          end;


      end;
          Inc(Changed);

  //    finfoforn[idx]

      if idx >= 0 then
        fInfoFont[idx].DrawTo(fimg.Bitmap, x, 0)
      else
        fimg.Bitmap.FillRectS(x, y, x + 8, y + 16, 0);
    end;

    Inc(x, 8);

  end;

  RedrawnChars := Changed;


//  fImg.Bitmap.
end;


procedure TSkillPanelToolbar.DrawSkillCount(aButton: TButtonSkill; aNumber: Integer);
var
  S: string;
  L, R: Char;
  BtnIdx: Integer;
  DstRect, SrcRect: TRect;

  c:tcolor32;

const
  FontYPos = 17;
//  Font

begin
  // x = 3, 19, 35 etc. are the "black holes" for the numbers in the image
  // y = 17

//  if aNumber < 0 then
  //  aNumber
  Restrict(aNumber, 0, 99);
//  Assert(Between(aNumber, 0, 99), 'skillpanel number error 1');

  S := LeadZeroStr(aNumber, 2);
  L := S[1];
  R := S[2];

  BtnIdx := Ord(aButton);

  // white nothing if number is zero
  if aNumber = 0 then
  begin
    DstRect := Rect(BtnIdx * 16 + 4, 17, BtnIdx * 16 + 4 + 8, 17 + 8);
    c:=Color32(60*4, 52*4, 52*4);
    with DstRect do
      fImg.Bitmap.FillRect(Left, Top, Right, Bottom, c); //
      { TODO : use other WHITE }      //=60,52,52 (*4)
    Exit;
  end;

  // left
  DstRect := Rect(BtnIdx * 16 + 4, 17, BtnIdx * 16 + 4 + 4, 17 + 8);
  SrcRect := Rect(0, 0, 4, 8);
  fSkillFont[L, 1].DrawTo(fImg.Bitmap, DstRect, SrcRect); // 1 is left

  // right
  RectMove(DstRect, 4, 0);
  SrcRect := Rect(4, 0, 8, 8);
  fSkillFont[R, 0].DrawTo(fImg.Bitmap, DstRect, SrcRect); // 0 is right

//  with
//  fimg.Bitmap.FillRect(0, 0, 20, 20, clwhite32);
//  fSkillFont[R, 1].DrawTo(fImg.Bitmap, BtnIdx * 16 + 3, 17)
end;

procedure TSkillPanelToolbar.RedrawAndUpdateInfo;
begin
  DrawNewStr;
  fLastDrawnStr := fNewDrawStr;// := fLastDrawnStr;
end;



procedure TSkillPanelToolbar.ImgMouseDown(Sender: TObject; Button: TMouseButton;
    Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
{-------------------------------------------------------------------------------
  Mouse down behaviour.
  o Minimap scrolling
  o Button clicks
-------------------------------------------------------------------------------}
var
  P: TPoint;
  iSkill: TButtonSkill;
  R: PRect;
  Exec: Boolean;
begin
  // convert mousecoord to zoomed bitmap
  P := Img.ControlToBitmap(Point(X, Y));

  // check minimap scroll
  if PtInRectEx(MiniMapBounds, P) then
  begin
    Dec(P.X, MinimapBounds.Left);
    Dec(P.Y, MiniMapBounds.Top);
    P.X := P.X * 16;
    P.Y := P.Y * 8;
    Game.MiniMapClick(P);
    Exit;
  end;

  // check rectangles buttons
  for iSkill := Low(TButtonSkill) to High(TButtonSkill) do
  begin

    R := @fButtonRects[iSkill];

    if PtInRectEx(R^, P) then
    begin
      if Game.SkillButtonsDisabledWhenPaused then
        Exec := not Game.Paused or (iSkill = bskPause)
      else
        Exec := True;

      if Exec then
        if iSkill = bskNuke then
          Exec := ssDouble in Shift;

      if Exec then
      begin
        if iSkill <> bskPause then
          Game.RegainControl;
        Game.SetSelectedSkill(iSkill, True);
      end;
      Exit;
    end;

  end;
end;

procedure TSkillPanelToolbar.ImgMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
var
  P: TPoint;
begin
  if ssLeft in Shift then
  begin
    P := Img.ControlToBitmap(Point(X, Y));

    if PtInRectEx(MiniMapBounds, P) then
    begin
      Dec(P.X, MinimapBounds.Left);
      Dec(P.Y, MiniMapBounds.Top);
      P.X := P.X * 16;
      P.Y := P.Y * 8;
      Game.MiniMapClick(P);
    end;
  end;
end;

procedure TSkillPanelToolbar.ImgMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer;
  Layer: TCustomLayer);
begin
  { TODO : This kind of things should really be better programmed! }
  if not Game.Replaying then
  begin
    Game.SetSelectedSkill(bskSlower, False);
    Game.SetSelectedSkill(bskFaster, False);
  end;
end;




procedure TSkillPanelToolbar.ReadBitmapFromStyle;
var
  Sty: TBaseDosStyle;//TDosOrigStyle;
  c: char; i: Integer;
  pal: TDOSGroundVGAPaletteArray8;
  Extr: TMainDatExtractor;
//  pal
begin

  if not (fStyle is TBaseDosStyle) then
    Exit;

  Sty := TBaseDosStyle(fStyle);
//  TDosOrigStyle(fStyle);

  Extr := TMainDatExtractor.Create(Sty.IncludeCommonPath(Sty.MainDataFile));

  with Extr do
  begin
    SetButtonRects;

    // whole panel
    { TODO : christmas lemmings, fix it the inlevelpalette is different }
//    if sty is TDosChristmas91Style then
  //    ExtractSkillPanel(fOriginal, DosInLevelPaletteChristmas{fGraph.PaletteStandard})
    //else
      ExtractSkillPanel(fOriginal, DosInLevelPalette{fGraph.PaletteStandard});
    fImg.Bitmap.Assign(fOriginal);

    // info fonts
    DoExtract(6);
    fMems[6].Seek($1900, soFromBeginning);
    for i := 0 to 37 do
      fPlanar.LoadFromStream(fMems[6], fInfofont[i], -1, 8,16, 3, DosInLevelPalette, DosInLevelPalette);


    // skill fonts
    DoExtract(2);

    { TODO : christmas lemmings, fix it }
    pal := fGraph.palettestandard; {DosInLevelPalette;}
    pal[1] := pal[3]; // WHITE
    fmems[2].seek($1900, sofrombeginning);
    for c := '0' to '9' do
      for i := 0 to 1 do
      begin
        fPlanar.LoadFromStream(fMems[2], fSkillFont[c, i], -1, 8, 8, 1, pal, pal);
        //fSkillFont[c,i].savetofile(AppPath+'temp\'+'skillfont_' + c + i2s(i) + '.bmp');
      end;

    Free;
  end;
  //fbitmap.savetofile(apppath+'sp.bmp');
end;

procedure TSkillPanelToolbar.ReadFont;
begin

end;

procedure TSkillPanelToolbar.SetButtonRects;
var
  Org, R: TRect;
  iButton: TButtonSkill;
//  Sca: Integer;

//    function ScaleRect(const ):

begin
//  Sca := 3;
  Org := Rect(1, 16, 15, 38); // exact position of first button
  R := Org;
  {R.Left := R.Left * Sca;
  R.Right := R.Right * Sca;
  R.Top := R.Top * Sca;
  R.Bottom := R.Bottom * Sca; }

  for iButton := Low(TButtonSkill) to High(TButtonSkill) do
  begin
    fButtonRects[iButton] := R;
    RectMove(R, 16{ * Sca}, 0);
  end;

end;

procedure TSkillPanelToolbar.SetInfoCursorLemming(const Lem: string; Num: Integer);
var
  S: string;
begin
  if Lem <> '' then
  begin

    S := PadR(Lem + ' ' + i2s(Num), 14); //
    Move(S[1], fNewDrawStr[1], 14);
  end
  else begin
    S := '              ';
    Move(S[1], fNewDrawStr[1], 14);
  end;
end;

procedure TSkillPanelToolbar.SetInfoError(const Error: string; Code: Integer);
begin

end;

procedure TSkillPanelToolbar.SetInfoLemmingsOut(Num: Integer);
var
  S: string;
begin
  // stringspositions cursor,out,in,time = 1,15,24,32
  //fNewDrawStr := '..............' + 'OUT_.....' + 'IN_.....' + 'TIME_.-..';
  S := PadR(i2s(Num), 5);
  Move(S[1], fNewDrawStr[19], 5);
end;

procedure TSkillPanelToolbar.SetInfoLemmingsIn(Num, Max: Integer);
var
  S: string;
begin
  // stringspositions cursor,out,in,time = 1,15,24,32
  //fNewDrawStr := '..............' + 'OUT_.....' + 'IN_.....' + 'TIME_.-..';
  { TODO : percentage }
  S := PadR(i2s(percentage(Max, Num)) + '%', 5);
  Move(S[1], fNewDrawStr[27], 5);
end;

procedure TSkillPanelToolbar.SetInfoMinutes(Num: Integer);
var
  S: string;
begin
  // stringspositions cursor,out,in,time = 1,15,24,32
  //fNewDrawStr := '..............' + 'OUT_.....' + 'IN_.....' + 'TIME_.-..';
  S := PadL(i2s(Num), 2);
  Move(S[1], fNewDrawStr[36], 2);
end;

procedure TSkillPanelToolbar.SetInfoSeconds(Num: Integer);
var
  S: string;
begin
  // stringspositions cursor,out,in,time = 1,15,24,32
  //fNewDrawStr := '..............' + 'OUT_.....' + 'IN_.....' + 'TIME_.-..';
  S := LeadZeroStr(Num, 2);
  Move(S[1], fNewDrawStr[39], 2);
end;

procedure TSkillPanelToolbar.SetLevel(const Value: TLevel);
begin
  fLevel := Value;
end;

procedure TSkillPanelToolbar.SetStyleAndGraph(const Value: TBaseLemmingStyle;
      const aGraph: TBaseDosGraphicSet;
      aScale: Integer);
begin
  fImg.BeginUpdate;
  fStyle := Value;
  fGraph := aGraph;
  if fStyle <> nil then
  begin
    ReadBitmapFromStyle;
    ReadFont;
  end;
//  Width := fBitmap.Width;
//  Height := fBitmap.Height;
  fImg.Scale := aScale;
  fImg.ScaleMode := smScale;
  //fImg.AutoSize := True;

  fImg.Height := fOriginal.Height * aScale;
  fImg.Width := fOriginal.Width * aScale;
  Width := fImg.Width;
  Height := fImg.Height;

//  AutoSize := True;
//  fImg.Width * fImg.Bitmap.Width

//  DrawNumber(bskClimber, 23);
//  DrawInfo('1234567890123456789012345678901234567890');


  fImg.EndUpdate;
  fImg.Changed;
  Invalidate;
end;

procedure TSkillPanelToolbar.SetViewPort(const R: TRect);
begin
  fViewPortRect := R;
//  fMinimapHighlightLayer.Changed;

end;

procedure TSkillPanelToolbar.DrawMinimap(Map: TBitmap32);
begin
  Map.DrawTo(Img.Bitmap, 208, 18);
end;

procedure TSkillPanelToolbar.SetGame(const Value: TLemmingGame);
begin
  fGame := Value;
  if fGame <> nil then
    fGame.InfoPainter := Self
//  else
  //  fGame.InfoPainter := nil;  
end;

procedure TSkillPanelToolbar.SkillFontCombine(F: TColor32; var B: TColor32;
  M: TColor32);
begin
  if F <> 0 then
    B := clBlue32
  else
    B := clBlack32;  
end;

{ TDosScreen }

constructor TDosScreen.Create(aOwner: TComponent);
begin
  inherited Create(aOwner);
  fImg := TImage32.Create(Self);
  fImg.Align := alClient;
//  fImg.WindowProc
  fImg.BitmapAlign := baTile;
//  fImg.Scale := 3;
//  fBackGround := TBitmap32.Create;

end;

destructor TDosScreen.Destroy;
begin
//  fBackGround.Free;
  inherited;
end;

procedure TDosScreen.SetMainDat(const Value: string);
var
  Dat: TMainDatExtractor;
begin
  if CompareText(fMainDat, Value) = 0 then
    Exit;
  fMainDat := Value;
  Dat := TMainDatExtractor.Create(Value);
  try
    Dat.DoExtract(3);
    Dat.Planar.LoadFromStream(Dat.fMems[3], fImg.Bitmap, 0, 320, 104, 2, DosMainMenuPalette);
  finally
    Dat.Free;
  end;
end;

end.
(*
    procedure DoSetScale(aScale: Integer);
procedure TSkillPanelToolbar.DoSetScale(aScale: Integer);
begin
  fImg.Scale := aScale;
  fImg.ScaleMode := smScale;
  fImg.AutoSize := True;
  AutoSize := True;
end;


(*
  dosgame

  1. mainform
     Put en delete daarop screens (mainmenu, intro, game, congrats)
  2. decompressor
  3. levelextraction
  4. graphics
  5. player

*)




(* cursor code

unit Unit1;

interface

{

How to Convert a Bitmap to a Cursor

http://delphi.about.com/od/adptips2005/qt/bmp2cur.htm

Let's say you have a bitmap (BMP) image you would like
to convert to a cursor and use in your application.
Here's what you need to do...

~Zarko Gajic
About Delphi Proramming
http://delphi.about.com

}


uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Image2: TImage;
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

const
  crMyCursor = 1; //any number > 0
var
  iconInfo : TIconInfo;

implementation
{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  bmpMask : TBitmap;
  bmpColor : TBitmap;
begin
  bmpMask := TBitmap.Create;
  bmpColor := TBitmap.Create;

  bmpMask.LoadFromFile('CircleMask.bmp');
  bmpColor.LoadFromFile('Circle.bmp');

  with iconInfo do
  begin
    fIcon := false;
    xHotspot := 15;
    yHotspot := 15;
    hbmMask := bmpMask.Handle;
    hbmColor := bmpColor.Handle;
  end;

  Screen.Cursors[crMyCursor] := CreateIconIndirect(iconInfo);
  
  Screen.Cursor := crMyCursor;

  bmpMask.Free;
  bmpColor.Free;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  DestroyIcon(Screen.Cursors[crMyCursor]);
end;

end. gr32_image

lemapp


