{$include lem_directives.inc}
(*






Cheats:

Ob ein Level geschafft ist, wird in der Datei LEMMINGS.DB vermerkt.
In der Tabelle finden Sie den Offset fr Level 1 jedes Rating.
Der Inhalt 00 steht fr Level nicht geschafft, 01 fr geschafft.
Fr jeden weiteren Level addieren Sie jeweils 89H hinzu.
Beispiel: Um den ersten Level fr Rating Tame zu umgehen,
tragen Sie eine 01 in 4143H ein, fr den zweiten in (4143H + 89H =) 41CCH.
Nebenbei gesagt, Taschenrechner, die Hexzahlen addieren knnen, gibt es schon fr 15 Mark.

Rating	Offset fr Level 1	 	Rating	Offset fr Level 1
Fun	194	 	                     Crazy	4A5C
Tricky	1119	 	              Wild	5599
Taxing	209E	            	Wicked	60d6
Mayhem	30AC	               	Havoc	6B8A
Tame	4143	 	 	 

*)

unit LemWinStyles;

interface
uses
  Windows, Classes, IniFiles, SysUtils,
  UMisc, GR32, GraphicEx,
  LemDosFiles, LemFiles,
  LemTypes, LemCore;

type
  TBaseWinStyle = class(TBaseLemmingStyle);

  TWinLoResStyle = class(TBaseWinStyle)
  private
  protected
  public
    class procedure GetStyleParams(var aParams: TDefaultsRec); override;
    class function GetLevelLoaderClass: TBaseLevelLoaderClass; override;
  published
  end;

  TWinHiResStyle = class(TBaseWinStyle)
  private
  protected
  public
    class procedure GetStyleParams(var aParams: TDefaultsRec); override;
    class function GetLevelLoaderClass: TBaseLevelLoaderClass; override;
  published
  end;

{-------------------------------------------------------------------------------
  Graphic Sets section
-------------------------------------------------------------------------------}

  TBaseWinGraphicSet = class(TBaseGraphicSet) // do not register
  private
  protected
    fPaletteFile  : string; // the palette used (i.e. brick.pal)
    fMetaInfoFile : string; // the file which contains metadata (i.e: brick.dat)
    fTerrainFile  : string; // the sprite file with terrain graphics (i.e: bricks.spr)
    fObjectFile   : string; // the sprite file with object graphics (i.e: brickos.spr)

    fColors       : array of TColor32Entry; // this is read from the palettefile
  public
    procedure DirectReadData; override;
    procedure DirectGetTerrainBitmap(aIndex: Integer; aBitmap: TBitmap32); override;
    procedure DirectGetObjectBitmap(aIndex: Integer; aBitmap: TBitmap32); override;
  published
    property MetaInfoFile: string read fMetaInfoFile write fMetaInfoFile;
    property ObjectFile: string read fObjectFile write fObjectFile;
    property TerrainFile: string read fTerrainFile write fTerrainFile;
    property PaletteFile: string read fPaletteFile write fPaletteFile;
  end;

  TWinLoResGraphicSet = class(TBaseWinGraphicSet)
  private
//    procedure AdjustMetaData;
  protected
  public
    procedure DirectReadMetaData; override;
  published
  end;

  TWinHiResGraphicSet = class(TBaseWinGraphicSet)
  private
  protected
  public
    procedure DirectReadMetaData; override;
  published
  end;

  TWinLevelLoader = class(TBaseLevelLoader)
  protected
    procedure InternalLoadLevel(aInfo: TLevelInfo; aLevel: TLevel); override;
    procedure InternalPrepare; override;
  end;


implementation

//const
(*  SectionTable: TDosOrigLevelOrderTable = (
    (
       147, 155, 157, 149, 151, 153, 159,  14,  22,  54,
        70,  16,  29,  32,  38,  42,  48,  72,  84, 104,
       138,  23,  68,  96,  98, 116,  78, 100, 108, 134
    ),
    (
         1,  30,  36,  50,  52,  56,  58,  80, 102, 120,
       128, 130, 136,   5, 148, 152, 154, 156, 160,   7,
        11,  13,  15,  17,  19,  21,  25,  27,  33,  31
    ),
    (
       37, 39, 41, 43, 45, 47, 49, 51, 53, 55,
       57, 59, 61, 63,  3, 65, 67, 69, 71, 73,
       75, 77, 79, 81, 83, 85, 87, 89, 35,111
    ),
    (
        91,  93,  95,  97,  99, 101, 103, 105, 107, 109,
       112, 113, 115, 117, 119, 121, 123, 125, 127, 150,
       129,   9, 131, 133, 135, 137, 139, 141, 143, 145
    )
  );*)

{ TWinLoResStyle }

class function TWinLoResStyle.GetLevelLoaderClass: TBaseLevelLoaderClass;
begin
  Result := nil;
//  Result := TWinLevelLoader;
end;

class procedure TWinLoResStyle.GetStyleParams(var aParams: TDefaultsRec);
begin
  with aParams do
  begin
    Resolution   := 1.0;
    LevelWidth   := 1600;
    LevelHeight  := 160;
    ViewWidth    := 320;
    ViewHeight   := 200;
    MultiPacks := True;
  end;
end;

{ TWinHiResStyle }

class function TWinHiResStyle.GetLevelLoaderClass: TBaseLevelLoaderClass;
begin
  Result := nil;
//  Result := TWinLevelLoader;
end;

class procedure TWinHiResStyle.GetStyleParams(var aParams: TDefaultsRec);
begin
  with aParams do
  begin
    Resolution   := 2.0;
    LevelWidth   := 3200;
    LevelHeight  := 320;
    ViewWidth    := 640;
    ViewHeight   := 400;
    MultiPacks := True;
  end;
end;

{ TBaseWinGraphicSet }

procedure TBaseWinGraphicSet.DirectGetObjectBitmap(aIndex: Integer; aBitmap: TBitmap32);
{-------------------------------------------------------------------------------
  This method works, but has even more overhead than the terrain method:
  verrrrrrry slow
-------------------------------------------------------------------------------}
var
  Pal: TPalFile;
  Obj: TSPRFile;
  Bmp: TBitmap32;
  MO: TMetaObject;
  First, i, Y: Integer;

    function GetFirstEntry: Integer;
    var
      i: Integer;
    begin
      Result := 0;
      for i := 0 to aIndex - 1 do
      begin
        Inc(Result, MetaObjectCollection[i].EndAnimationFrameIndex);
      end;
    end;

begin
  EnsureMetaData;
  Pal := TPalFile.Create;
  Obj := TSPRFile.Create;
  Bmp := TBitmap32.Create;
  try
    Pal.LoadFromFile(IncludeCommonStylePath(fPaletteFile));
    Obj.LoadFromFile(IncludeCommonStylePath(fObjectFile));
    MO := MetaObjectCollection[aIndex];
    aBitmap.SetSize(MO.Width, MO.Height * MO.EndAnimationFrameIndex);
    Y := 0;
    First := GetFirstEntry;
    for i := First to First + MO.EndAnimationFrameIndex - 1 do
    begin
      Obj.ConstructBitmap(i, Bmp, Pal.fColors);
      Bmp.DrawTo(aBitmap, 0, Y);
      Inc(Y, MO.Height);
    end;
  finally
    Pal.Free;
    Obj.Free;
    Bmp.Free;
  end;
end;

procedure TBaseWinGraphicSet.DirectGetTerrainBitmap(aIndex: Integer; aBitmap: TBitmap32);
{-------------------------------------------------------------------------------
  This method works, but very very slow and with very very much overhead,
  so we need to optimize this.
-------------------------------------------------------------------------------}
var
  Pal: TPalFile;
  Ter: TSPRFile;
begin
  Pal := TPalFile.Create;
  Ter := TSPRFile.Create;
  try
    Pal.LoadFromFile(IncludeCommonStylePath(fPaletteFile));
    Ter.LoadFromFile(IncludeCommonStylePath(fTerrainFile));
    Ter.ConstructBitmap(aIndex, aBitmap, Pal.fColors);
  finally
    Pal.Free;
    Ter.Free;
  end;
end;

procedure TBaseWinGraphicSet.DirectReadData;
begin

end;

{ TWinLoResGraphicSet }

procedure TWinLoResGraphicSet.DirectReadMetaData;
{-------------------------------------------------------------------------------
  Winlemmings uses the old dos files for metadata. These are plain copies.
  So we can just copy this into our own meta-structures.
-------------------------------------------------------------------------------}
var
  G: TDosGround;
  i: Integer;
  O: PDOSGroundObject;
  MO: TMetaObject;
  T: PDOSGroundTerrain;
  MT: TMetaTerrain;
begin
  G := TDosGround.Create;
  try
    G.LoadFromFile(IncludeCommonStylePath(fMetaInfoFile));
    with G.GroundRec do
    begin
      // objects
      for i := Low(ObjectInfoArray) to High(ObjectInfoArray) do
      begin
        O := @ObjectInfoArray[i];
//        deb([ObjectInfoArray[i].owidth]);
        if O^.oWidth = 0 then
          Break;
        MO := MetaObjectCollection.Add;
        with MO do
        begin
          AnimationFlags           := O^.oAnimation_flags;
          StartAnimationFrameIndex := O^.oStart_animation_frame_index;
          EndAnimationFrameIndex   := O^.oEnd_animation_frame_index;
//          AnimationFrameDataSize   := O^.oAnimation_frame_data_size;
//          MaskOffsetFromImage      := O^.oMask_offset_from_image;
          Width                    := O^.oWidth;
          Height                   := O^.oHeight;
          TriggerLeft              := O^.oTrigger_left * 4;
          TriggerTop               := O^.oTrigger_top * 4 - 4;
          TriggerWidth             := O^.oTrigger_width * 4;
          TriggerHeight            := O^.oTrigger_height * 4;
          TriggerEffect            := O^.oTrigger_effect_id;

          { TODO : index like dos }       // this is really fake!

          PreviewFrameIndex        := //O^.oPreview_image_location;
            (O^.oPreview_image_location - O^.oAnimation_frames_base_loc) div O^.oAnimation_frame_data_size;

          TrapSoundEffect          := O^.oTrap_sound_effect_id;
        end;
      end;
      // terrains
      for i := Low(TerrainInfoArray) to High(TerrainInfoArray) do
      begin
        T := @TerrainInfoArray[i];
        if T^.tWidth = 0 then
          Break;
        MT := MetaTerrainCollection.Add;
        with MT do
        begin
          Width := T^.tWidth;
          Height := T^.tHeight;
        end;
      end;
    end;
  finally
    G.Free;
  end;
end;

{ TWinHiResGraphicSet }

procedure TWinHiResGraphicSet.DirectReadMetaData;
{-------------------------------------------------------------------------------
  Winlemmings uses the old dos files for metadata. These are plain copies.
  So we can just copy this into our own meta-structures.
  This is a copy of WinLoRes, except that sizes are doubled.
-------------------------------------------------------------------------------}
var
  G: TDosGround;
  i: Integer;
  O: PDOSGroundObject;
  MO: TMetaObject;
  T: PDOSGroundTerrain;
  MT: TMetaTerrain;
begin
  G := TDosGround.Create;
  try
    G.LoadFromFile(IncludeCommonStylePath(fMetaInfoFile));
    with G.GroundRec do
    begin
      // objects
      for i := Low(ObjectInfoArray) to High(ObjectInfoArray) do
      begin
        O := @ObjectInfoArray[i];
        if O^.oWidth = 0 then
          Break;
        MO := MetaObjectCollection.Add;
        with MO do
        begin
          AnimationFlags           := O^.oAnimation_flags;
          StartAnimationFrameIndex := O^.oStart_animation_frame_index;
          EndAnimationFrameIndex   := O^.oEnd_animation_frame_index;
//          AnimationFrameDataSize   := O^.oAnimation_frame_data_size;
//          MaskOffsetFromImage      := O^.oMask_offset_from_image;
          Width                    := 2 * O^.oWidth;
          Height                   := 2 * O^.oHeight;
          TriggerLeft              := 2 * (O^.oTrigger_left * 4); 
          TriggerTop               := 2 * (O^.oTrigger_top * 4 - 4);
          TriggerWidth             := 2 * (O^.oTrigger_width * 4);
          TriggerHeight            := 2 * (O^.oTrigger_height * 4);
          TriggerEffect            := O^.oTrigger_effect_id;

          { TODO : AAAAAAAARGH } // fake
          PreviewFrameIndex        := //O^.oPreview_image_location;

            (O^.oPreview_image_location - O^.oAnimation_frames_base_loc) div O^.oAnimation_frame_data_size;


          TrapSoundEffect          := O^.oTrap_sound_effect_id;
        end;
      end;
      // terrains
      for i := Low(TerrainInfoArray) to High(TerrainInfoArray) do
      begin
        T := @TerrainInfoArray[i];
        if T^.tWidth = 0 then
          Break;
        MT := MetaTerrainCollection.Add;
        with MT do
        begin
          Width := 2 * T^.tWidth;
          Height := 2 * T^.tHeight;
        end;
      end;
    end;
  finally
    G.Free;
  end;
end;


{ TWinLevelLoader }

procedure TWinLevelLoader.InternalLoadLevel(aInfo: TLevelInfo; aLevel: TLevel);
begin
end;


procedure TWinLevelLoader.InternalPrepare;
var
  Data: PWinLemDB;
begin
  New(Data);
  try

  finally
    Dispose(Data);
  end;
end;

end.

(*
procedure TWinLevelLoader.InternalPrepare;
{-------------------------------------------------------------------------------
  Load all level info
-------------------------------------------------------------------------------}
const
  OrigSectionNames: array[0..3] of string = ('Fun', 'Tricky', 'Taxing', 'Mayhem');
  OhNoSectionNames: array[0..4] of string = ('Tame','Crazy','Wild','Wicked','Havoc');
var
  LocalSectionNames: TStringList;
  iPack, iSection, iLevel: Integer;
  Pack: TLevelPack;
  Section: TPackSection;
  LevelInfo: TLevelInfo;
  Fn1, Fn: string;
  IsOdd: Boolean;
  OddIndex: Integer;
  FileIndex: Integer;
  Sty: TBaseWinStyle;

  OddTable: TDosOddTable;
  Arc: TDosDatArchive;

    function GetOddTitle(Inf: TLevelInfo): string;
    var
      Ox: Integer;
    begin
      Result := StringOfChar(' ', 32);
      Ox := Inf.DosOddTableIndex;
      move(OddTable.recs[ox].LevelName, result[1], 32);
    end;

    procedure GetSectionNames(aPack: Integer);
    var
      i: Integer;
    begin
      LocalSectionNames.Clear;
      case aPack of
        0: for i := 0 to 3 do
          LocalSectionNames.Add(origsectionNames[i])
      end;
    end;

begin
  OddTable := nil;
  if not (Owner is TBaseWinStyle) then
    raise Exception.Create('base dos level loader error');

//  LocalSectionNames := TStringList.Create;
  Sty := TBaseWinStyle(Owner);
  Arc := TDosDatArchive.Create;

  TRY


  if Sty.OddTableFile <> '' then
  begin
    OddTable := TDosOddTable.Create;
    OddTable.LoadFromFile(Sty.IncludeCommonPath(Sty.OddTableFile));
  end;

  for iPack := 0 to 1 do
  begin
    GetSectionNames(iPack);
    // default pack
    Pack := fLevelPacks.Add;
    Pack.LevelPackName := 'Default';
    // sections
    for iSection := 0 to LocalSectionNames.Count - 1 do
    begin
      Section := Pack.PackSections.Add;
      Section.SectionName := LocalSectionNames[iSection];
      //deb([section.sectionname + '_' + i2s(iSection)]);
      // levels
      for iLevel := 0 to GetLevelCount(iSection) - 1 do
      begin
        IsOdd := False;
        OddIndex := -1;
        FileIndex := -1;
        Fn := '';
        GetEntry(iSection{ + 1}, iLevel{ + 1}, Fn, FileIndex, IsOdd, OddIndex);
        Fn1 := Fn;
        Fn := Sty.IncludeCommonPath(Fn);
        LevelInfo := Section.LevelInfos.Add;
  //      LevelInfo.iOwnerFile := '';
        LevelInfo.DosLevelPackFileName := Fn;
        LevelInfo.DosLevelPackIndex := FileIndex;
        LevelInfo.DosIsOddTableClone := IsOdd;
        LevelInfo.DosOddTableIndex := OddIndex;
        if IsOdd then
          LevelInfo.DosOddTableFileName := Sty.IncludeCommonPath(Sty.OddTableFile);
        {
        with LevelInfo do
          deb([section.sectionname + '_' + i2s(iLevel) + '=' + Fn1 + ',' + i2s(FileIndex) + ',' + i2s(OddIndex)]);
        }
        Arc.LoadFromFile(Fn);
  //      DEB)(
        if not IsOdd then
          LevelInfo.TrimmedTitle := Trim(Arc.ExtractLevelTitle(FileIndex))
        else begin
          LevelInfo.TrimmedTitle := Trim(GetOddTitle(LevelInfo))
        end;
  //      'level ' + i2s(iLevel + 1); // lemtools
  //      LevelInfo.iOwnerIndex
        //raise exception.create('ERROR NOT FINISHED'); //kernel_resource
      end;
    end;

  end;

  FINALLY

  Arc.Free;
  if OddTable <> nil then
    OddTable.Free;
  LocalSectionNames.Free;

  END;
end;

